diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/helper/ipv6-routing-helper.cc ns-3.33/src/internet/helper/ipv6-routing-helper.cc
--- ns-3.32/src/internet/helper/ipv6-routing-helper.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/helper/ipv6-routing-helper.cc	2021-01-09 10:19:22.000000000 -0800
@@ -93,39 +93,39 @@
 }
 
 void
-Ipv6RoutingHelper::PrintNeighborCacheAllAt (Time printTime, Ptr<OutputStreamWrapper> stream)
+Ipv6RoutingHelper::PrintNeighborCacheAllAt (Time printTime, Ptr<OutputStreamWrapper> stream, Time::Unit unit /* = Time::S */)
 {
   for (uint32_t i = 0; i < NodeList::GetNNodes (); i++)
     {
       Ptr<Node> node = NodeList::GetNode (i);
-      Simulator::Schedule (printTime, &Ipv6RoutingHelper::PrintNdiscCache, node, stream);
+      Simulator::Schedule (printTime, &Ipv6RoutingHelper::PrintNdiscCache, node, stream, unit);
     }
 }
 
 void
-Ipv6RoutingHelper::PrintNeighborCacheAllEvery (Time printInterval, Ptr<OutputStreamWrapper> stream)
+Ipv6RoutingHelper::PrintNeighborCacheAllEvery (Time printInterval, Ptr<OutputStreamWrapper> stream, Time::Unit unit /* = Time::S */)
 {
   for (uint32_t i = 0; i < NodeList::GetNNodes (); i++)
     {
       Ptr<Node> node = NodeList::GetNode (i);
-      Simulator::Schedule (printInterval, &Ipv6RoutingHelper::PrintNdiscCacheEvery, printInterval, node, stream);
+      Simulator::Schedule (printInterval, &Ipv6RoutingHelper::PrintNdiscCacheEvery, printInterval, node, stream, unit);
     }
 }
 
 void
-Ipv6RoutingHelper::PrintNeighborCacheAt (Time printTime, Ptr<Node> node, Ptr<OutputStreamWrapper> stream)
+Ipv6RoutingHelper::PrintNeighborCacheAt (Time printTime, Ptr<Node> node, Ptr<OutputStreamWrapper> stream, Time::Unit unit /* = Time::S */)
 {
-  Simulator::Schedule (printTime, &Ipv6RoutingHelper::PrintNdiscCache, node, stream);
+  Simulator::Schedule (printTime, &Ipv6RoutingHelper::PrintNdiscCache, node, stream, unit);
 }
 
 void
-Ipv6RoutingHelper::PrintNeighborCacheEvery (Time printInterval,Ptr<Node> node, Ptr<OutputStreamWrapper> stream)
+Ipv6RoutingHelper::PrintNeighborCacheEvery (Time printInterval,Ptr<Node> node, Ptr<OutputStreamWrapper> stream, Time::Unit unit /* = Time::S */)
 {
-  Simulator::Schedule (printInterval, &Ipv6RoutingHelper::PrintNdiscCacheEvery, printInterval, node, stream);
+  Simulator::Schedule (printInterval, &Ipv6RoutingHelper::PrintNdiscCacheEvery, printInterval, node, stream, unit);
 }
 
 void
-Ipv6RoutingHelper::PrintNdiscCache (Ptr<Node> node, Ptr<OutputStreamWrapper> stream)
+Ipv6RoutingHelper::PrintNdiscCache (Ptr<Node> node, Ptr<OutputStreamWrapper> stream, Time::Unit unit /* = Time::S */)
 {
   Ptr<Ipv6L3Protocol> ipv6 = node->GetObject<Ipv6L3Protocol> ();
   if (ipv6)
@@ -142,7 +142,7 @@
         {
           *os << static_cast<int> (node->GetId ());
         }
-      *os << " at time " << Simulator::Now ().GetSeconds () << "\n";
+      *os << " at time " << Simulator::Now ().As (unit) << "\n";
 
       for (uint32_t i=0; i<ipv6->GetNInterfaces(); i++)
         {
@@ -156,7 +156,7 @@
 }
 
 void
-Ipv6RoutingHelper::PrintNdiscCacheEvery (Time printInterval, Ptr<Node> node, Ptr<OutputStreamWrapper> stream)
+Ipv6RoutingHelper::PrintNdiscCacheEvery (Time printInterval, Ptr<Node> node, Ptr<OutputStreamWrapper> stream, Time::Unit unit /* = Time::S */)
 {
   Ptr<Ipv6L3Protocol> ipv6 = node->GetObject<Ipv6L3Protocol> ();
   if (ipv6)
@@ -173,7 +173,7 @@
         {
           *os << static_cast<int> (node->GetId ());
         }
-      *os << " at time " << Simulator::Now ().GetSeconds () << "\n";
+      *os << " at time " << Simulator::Now ().As (unit) << "\n";
 
       for (uint32_t i=0; i<ipv6->GetNInterfaces(); i++)
         {
@@ -183,7 +183,7 @@
               ndiscCache->PrintNdiscCache (stream);
             }
         }
-      Simulator::Schedule (printInterval, &Ipv6RoutingHelper::PrintNdiscCacheEvery, printInterval, node, stream);
+      Simulator::Schedule (printInterval, &Ipv6RoutingHelper::PrintNdiscCacheEvery, printInterval, node, stream, unit);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/helper/ipv6-routing-helper.h ns-3.33/src/internet/helper/ipv6-routing-helper.h
--- ns-3.32/src/internet/helper/ipv6-routing-helper.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/helper/ipv6-routing-helper.h	2021-01-09 10:19:22.000000000 -0800
@@ -129,7 +129,7 @@
      \endverbatim
    * Note that the MAC address is printed as "type"-"size"-"actual address"
    */
-  static void PrintNeighborCacheAllAt (Time printTime, Ptr<OutputStreamWrapper> stream);
+  static void PrintNeighborCacheAllAt (Time printTime, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
 
   /**
    * \brief prints the neighbor cache of all nodes at regular intervals specified by user.
@@ -144,7 +144,7 @@
      \endverbatim
    * Note that the MAC address is printed as "type"-"size"-"actual address"
    */
-  static void PrintNeighborCacheAllEvery (Time printInterval, Ptr<OutputStreamWrapper> stream);
+  static void PrintNeighborCacheAllEvery (Time printInterval, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
 
   /**
    * \brief prints the neighbor cache of a node at a particular time.
@@ -160,7 +160,7 @@
      \endverbatim
    * Note that the MAC address is printed as "type"-"size"-"actual address"
    */
-  static void PrintNeighborCacheAt (Time printTime, Ptr<Node> node, Ptr<OutputStreamWrapper> stream);
+  static void PrintNeighborCacheAt (Time printTime, Ptr<Node> node, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
 
   /**
    * \brief prints the neighbor cache of a node at regular intervals specified by user.
@@ -176,7 +176,7 @@
      \endverbatim
    * Note that the MAC address is printed as "type"-"size"-"actual address"
    */
-  static void PrintNeighborCacheEvery (Time printInterval, Ptr<Node> node, Ptr<OutputStreamWrapper> stream);
+  static void PrintNeighborCacheEvery (Time printInterval, Ptr<Node> node, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
 
   /**
    * \brief Request a specified routing protocol &lt;T&gt; from Ipv6RoutingProtocol protocol
@@ -229,7 +229,7 @@
      \endverbatim
    * Note that the MAC address is printed as "type"-"size"-"actual address"
    */
-  static void PrintNdiscCache (Ptr<Node> node, Ptr<OutputStreamWrapper> stream);
+  static void PrintNdiscCache (Ptr<Node> node, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
 
   /**
    * \brief prints the neighbor cache of a node at regular intervals specified by user.
@@ -245,7 +245,7 @@
      \endverbatim
    * Note that the MAC address is printed as "type"-"size"-"actual address"
    */
-  static void PrintNdiscCacheEvery (Time printInterval, Ptr<Node> node, Ptr<OutputStreamWrapper> stream);
+  static void PrintNdiscCacheEvery (Time printInterval, Ptr<Node> node, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv4-interface-address.cc ns-3.33/src/internet/model/ipv4-interface-address.cc
--- ns-3.32/src/internet/model/ipv4-interface-address.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv4-interface-address.cc	2021-01-09 10:19:22.000000000 -0800
@@ -39,6 +39,10 @@
 {
   NS_LOG_FUNCTION (this << local << mask);
   m_local = local;
+  if (m_local == Ipv4Address::GetLoopback ())
+    {
+      m_scope = HOST;
+    }
   m_mask = mask;
   m_broadcast = Ipv4Address (local.Get () | (~mask.Get ()));
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv4-l3-protocol.cc ns-3.33/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.32/src/internet/model/ipv4-l3-protocol.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv4-l3-protocol.cc	2021-01-09 10:19:22.000000000 -0800
@@ -877,7 +877,7 @@
   Ptr<Ipv4Route> newRoute;
   if (m_routingProtocol != 0)
     {
-      newRoute = m_routingProtocol->RouteOutput (packet, ipHeader, oif, errno_);
+      newRoute = m_routingProtocol->RouteOutput (pktCopyWithTags, ipHeader, oif, errno_);
     }
   else
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv4-packet-info-tag.cc ns-3.33/src/internet/model/ipv4-packet-info-tag.cc
--- ns-3.32/src/internet/model/ipv4-packet-info-tag.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv4-packet-info-tag.cc	2021-01-09 10:19:22.000000000 -0800
@@ -30,7 +30,6 @@
 
 Ipv4PacketInfoTag::Ipv4PacketInfoTag ()
   : m_addr (Ipv4Address ()),
-    m_spec_dst (Ipv4Address ()),
     m_ifindex (0),
     m_ttl (0)
 {
@@ -52,20 +51,6 @@
 }
 
 void 
-Ipv4PacketInfoTag::SetLocalAddress (Ipv4Address addr)
-{
-  NS_LOG_FUNCTION (this << addr);
-  m_spec_dst = addr;
-}
-
-Ipv4Address
-Ipv4PacketInfoTag::GetLocalAddress (void) const
-{
-  NS_LOG_FUNCTION (this);
-  return m_spec_dst;
-}
-
-void 
 Ipv4PacketInfoTag::SetRecvIf (uint32_t ifindex)
 {
   NS_LOG_FUNCTION (this << ifindex);
@@ -116,9 +101,7 @@
 Ipv4PacketInfoTag::GetSerializedSize (void) const
 { 
   NS_LOG_FUNCTION (this);
-  return 4 + 4 
-         + sizeof (uint32_t)
-         + sizeof (uint8_t);
+  return 4 + sizeof (uint32_t) + sizeof (uint8_t);
 }
 void 
 Ipv4PacketInfoTag::Serialize (TagBuffer i) const
@@ -127,8 +110,6 @@
   uint8_t buf[4];
   m_addr.Serialize (buf);
   i.Write (buf, 4);
-  m_spec_dst.Serialize (buf);
-  i.Write (buf, 4);
   i.WriteU32 (m_ifindex);
   i.WriteU8 (m_ttl);
 }
@@ -139,8 +120,6 @@
   uint8_t buf[4];
   i.Read (buf, 4);
   m_addr = Ipv4Address::Deserialize (buf);
-  i.Read (buf, 4);
-  m_spec_dst = Ipv4Address::Deserialize (buf);
   m_ifindex = i.ReadU32 ();
   m_ttl = i.ReadU8 ();
 }
@@ -149,7 +128,6 @@
 {
   NS_LOG_FUNCTION (this << &os);
   os << "Ipv4 PKTINFO [DestAddr: " << m_addr;
-  os << ", Local Address:" << m_spec_dst;
   os << ", RecvIf:" << (uint32_t) m_ifindex;
   os << ", TTL:" << (uint32_t) m_ttl;
   os << "] ";
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv4-packet-info-tag.h ns-3.33/src/internet/model/ipv4-packet-info-tag.h
--- ns-3.32/src/internet/model/ipv4-packet-info-tag.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv4-packet-info-tag.h	2021-01-09 10:19:22.000000000 -0800
@@ -38,6 +38,11 @@
  * This is used with socket option such as IP_PKTINFO, IP_RECVTTL, 
  * IP_RECVTOS. See linux manpage ip(7).
  *
+ * See also SocketIpTosTag and SocketIpTtlTag
+ *
+ * The Tag does not carry the Local address (as it is not currently
+ * used to force a source address).
+ *
  * This tag in the send direction is presently not enabled but we
  * would accept a patch along those lines in the future.
  */
@@ -59,22 +64,6 @@
    * \returns the address
    */
   Ipv4Address GetAddress (void) const;
-  /**
-   * \brief Set the tag's \a local address
-   *
-   * This corresponds to "ipi_spec_dst" in struct in_pktinfo.
-   * Implemented, but not used in the stack yet
-   * \param addr the address
-   */
-  void SetLocalAddress (Ipv4Address addr);
-  /**
-   * \brief Get the tag's \a local address
-   *
-   * This corresponds to "ipi_spec_dst" in struct in_pktinfo.
-   * Implemented, but not used in the stack yet
-   * \returns the address
-   */
-  Ipv4Address GetLocalAddress (void) const;
 
   /**
    * \brief Set the tag's receiving interface
@@ -124,7 +113,6 @@
   // };
 
   Ipv4Address m_addr;     //!< Header destination address
-  Ipv4Address m_spec_dst; //!< Local address
   uint32_t m_ifindex;     //!< interface index
 
   // Used for IP_RECVTTL, though not implemented yet.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv4-queue-disc-item.cc ns-3.33/src/internet/model/ipv4-queue-disc-item.cc
--- ns-3.32/src/internet/model/ipv4-queue-disc-item.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv4-queue-disc-item.cc	2021-01-09 10:19:22.000000000 -0800
@@ -78,7 +78,7 @@
   os << GetPacket () << " "
      << "Dst addr " << GetAddress () << " "
      << "proto " << (uint16_t) GetProtocol () << " "
-     << "txq " << (uint8_t) GetTxQueueIndex ()
+     << "txq " << (uint16_t) GetTxQueueIndex ()
   ;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv4-raw-socket-impl.cc ns-3.33/src/internet/model/ipv4-raw-socket-impl.cc
--- ns-3.32/src/internet/model/ipv4-raw-socket-impl.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv4-raw-socket-impl.cc	2021-01-09 10:19:22.000000000 -0800
@@ -440,6 +440,8 @@
         {
           Ipv4PacketInfoTag tag;
           copy->RemovePacketTag (tag);
+          tag.SetAddress (ipHeader.GetDestination ());
+          tag.SetTtl (ipHeader.GetTtl ());
           tag.SetRecvIf (incomingInterface->GetDevice ()->GetIfIndex ());
           copy->AddPacketTag (tag);
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv6-packet-info-tag.h ns-3.33/src/internet/model/ipv6-packet-info-tag.h
--- ns-3.32/src/internet/model/ipv6-packet-info-tag.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv6-packet-info-tag.h	2021-01-09 10:19:22.000000000 -0800
@@ -37,6 +37,8 @@
  * data to the socket interface. This is used like 
  * socket option of IP_PKTINFO/IPV6_PKTINFO in \RFC{3542}
  *
+ * See also SocketIpv6TclassTag and SocketIpv6HopLimitTag
+ *
  * This tag in the send direction is presently not enabled but we
  * would accept a patch along those lines in the future. To include
  * the nexthop in the send direction would increase the size of the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv6-queue-disc-item.cc ns-3.33/src/internet/model/ipv6-queue-disc-item.cc
--- ns-3.32/src/internet/model/ipv6-queue-disc-item.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv6-queue-disc-item.cc	2021-01-09 10:19:22.000000000 -0800
@@ -78,7 +78,7 @@
   os << GetPacket () << " "
      << "Dst addr " << GetAddress () << " "
      << "proto " << (uint16_t) GetProtocol () << " "
-     << "txq " << (uint8_t) GetTxQueueIndex ()
+     << "txq " << (uint16_t) GetTxQueueIndex ()
   ;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/ipv6-raw-socket-impl.cc ns-3.33/src/internet/model/ipv6-raw-socket-impl.cc
--- ns-3.32/src/internet/model/ipv6-raw-socket-impl.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/ipv6-raw-socket-impl.cc	2021-01-09 10:19:22.000000000 -0800
@@ -437,6 +437,9 @@
         {
           Ipv6PacketInfoTag tag;
           copy->RemovePacketTag (tag);
+          tag.SetAddress (hdr.GetDestinationAddress ());
+          tag.SetHoplimit (hdr.GetHopLimit ());
+          tag.SetTrafficClass (hdr.GetTrafficClass ());
           tag.SetRecvIf (device->GetIfIndex ());
           copy->AddPacketTag (tag);
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/nsc-tcp-l4-protocol.cc ns-3.33/src/internet/model/nsc-tcp-l4-protocol.cc
--- ns-3.32/src/internet/model/nsc-tcp-l4-protocol.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/nsc-tcp-l4-protocol.cc	2021-01-09 10:19:22.000000000 -0800
@@ -119,7 +119,7 @@
 
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT                                   \
-  if (m_node) { std::clog << Simulator::Now ().GetSeconds () << " [node " << m_node->GetId () << "] "; } 
+  if (m_node) { std::clog << Simulator::Now ().As (Time::S) << " [node " << m_node->GetId () << "] "; } 
 
 TypeId 
 NscTcpL4Protocol::GetTypeId (void)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/nsc-tcp-socket-impl.cc ns-3.33/src/internet/model/nsc-tcp-socket-impl.cc
--- ns-3.32/src/internet/model/nsc-tcp-socket-impl.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/nsc-tcp-socket-impl.cc	2021-01-09 10:19:22.000000000 -0800
@@ -18,7 +18,7 @@
  */
 
 #define NS_LOG_APPEND_CONTEXT                                   \
-  if (m_node) { std::clog << Simulator::Now ().GetSeconds () << " [node " << m_node->GetId () << "] "; } 
+  if (m_node) { std::clog << Simulator::Now ().As (Time::S) << " [node " << m_node->GetId () << "] "; } 
 
 #include "ns3/node.h"
 #include "ns3/inet-socket-address.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/rtt-estimator.cc ns-3.33/src/internet/model/rtt-estimator.cc
--- ns-3.32/src/internet/model/rtt-estimator.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/rtt-estimator.cc	2021-01-09 10:19:22.000000000 -0800
@@ -211,8 +211,7 @@
 
   // RTTVAR <- (1 - beta) * RTTVAR + beta * |SRTT - R'|
   Time difference = Abs (err) - m_estimatedVariation;
-  m_estimatedVariation += Time::FromDouble (difference.ToDouble (Time::S) * m_beta, Time::S);
-
+  m_estimatedVariation += difference * m_beta;
   return;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-bic.cc ns-3.33/src/internet/model/tcp-bic.cc
--- ns-3.32/src/internet/model/tcp-bic.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-bic.cc	2021-01-09 10:19:22.000000000 -0800
@@ -273,14 +273,6 @@
   return ssThresh;
 }
 
-void
-TcpBic::ReduceCwnd (Ptr<TcpSocketState> tcb)
-{
-  NS_LOG_FUNCTION (this << tcb);
-
-  tcb->m_cWnd = std::max (tcb->m_cWnd.Get () / 2, tcb->m_segmentSize);
-}
-
 Ptr<TcpCongestionOps>
 TcpBic::Fork (void)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-bic.h ns-3.33/src/internet/model/tcp-bic.h
--- ns-3.32/src/internet/model/tcp-bic.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-bic.h	2021-01-09 10:19:22.000000000 -0800
@@ -103,7 +103,6 @@
                                uint32_t segmentsAcked);
   virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb,
                                 uint32_t bytesInFlight);
-  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
 
   virtual Ptr<TcpCongestionOps> Fork ();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-congestion-ops.cc ns-3.33/src/internet/model/tcp-congestion-ops.cc
--- ns-3.32/src/internet/model/tcp-congestion-ops.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-congestion-ops.cc	2021-01-09 10:19:22.000000000 -0800
@@ -250,14 +250,6 @@
   return std::max (2 * state->m_segmentSize, bytesInFlight / 2);
 }
 
-void
-TcpNewReno::ReduceCwnd (Ptr<TcpSocketState> tcb)
-{
-  NS_LOG_FUNCTION (this << tcb);
-
-  tcb->m_cWnd = std::max (tcb->m_cWnd.Get () / 2, tcb->m_segmentSize);
-}
-
 Ptr<TcpCongestionOps>
 TcpNewReno::Fork ()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-congestion-ops.h ns-3.33/src/internet/model/tcp-congestion-ops.h
--- ns-3.32/src/internet/model/tcp-congestion-ops.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-congestion-ops.h	2021-01-09 10:19:22.000000000 -0800
@@ -188,13 +188,6 @@
                             const TcpRateOps::TcpRateConnection &rc,
                             const TcpRateOps::TcpRateSample &rs);
 
-  /**
-   * \brief Reduces congestion window on receipt of ECN Echo Flag
-   *
-   * \param tcb internal congestion state
-   */
-  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb) = 0;
-
   // Present in Linux but not in ns-3 yet:
   /* call when ack arrives (optional) */
   //     void (*in_ack_event)(struct sock *sk, u32 flags);
@@ -243,7 +236,6 @@
   virtual void IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
   virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb,
                                 uint32_t bytesInFlight);
-  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
   virtual Ptr<TcpCongestionOps> Fork ();
 
 protected:
